#include <ctime>

typedef unsigned long long Timestamp; /* time in microseconds */
#define BILLION   1000000000LL

#define TIMER_RT CLOCK_REALTIME
#define TIMER_MT CLOCK_MONOTONIC
#define TIMER_PROCESS CLOCK_PROCESS_CPUTIME_ID
#define TIMER_THREAD CLOCK_THREAD_CPUTIME_ID

static Timestamp get_time(clockid_t timer)
{
    struct timespec tv;
    clock_gettime(timer, &tv);
    return (Timestamp) (tv.tv_sec * BILLION + tv.tv_nsec);
}

