/* 
 * Main entry of vector addition kernel
 */

#include <stdio.h>
#include <stdlib.h>

void matrixMultiply(float *C, float *A, float *B, int m, int k, int n);

/*
// Host matrix multiply
void matrixMulHost (int m, k, n, int *A, int *B, int *C) {

  for (int i = 0; i < m; i++)
  for (int j = 0; j < n; j++)
  for (int t = 0; t < k; t++)
    C[i*n + j] = A[i*k + t] + B[t*n + j];

  return;
}
*/

// Allocates a matrix with random float entries.
void randomInit(float* data, int size) {
  for (int i = 0; i < size; ++i)
    data[i] = rand() / (float)RAND_MAX;
}

int main (int argc, char *argv[]) {
  int m = atoi(argv[1]);
  int k = atoi(argv[2]);
  int n = atoi(argv[3]);

  float *A, *B, *C;

  /********************************************************************
  Allocate memory and initialize the input/output vectors
  ********************************************************************/

  A = (float *) malloc(m*k*sizeof(float));
  B = (float *) malloc(k*n*sizeof(float));
  C = (float *) malloc(m*n*sizeof(float));

  randomInit(A, m*k);
  randomInit(B, k*n);

  matrixMultiply(C, A, B, m, k, n);
    
  /********************************************************************
  Free memory allocations
  ********************************************************************/

  free(A); free(B); free(C);

  return 0;
}

