import sys
import re

regexSourceFile = re.compile(r"^source_filename.*")
regexMetadataLine = re.compile(r"^![0-9].*")
regexGEP = re.compile(r"(?P<prefix>.*)getelementptr(?P<attr>[A-Za-z ]*)? [<0-9 ]*[A-Zx>a-z 0-9%\.]*,")
regexGEPArr = re.compile(r"(?P<prefix>.*)getelementptr(?P<attr>[A-Za-z ]*)? \[.*],")
regexLoad = re.compile(r"(?P<prefix>.*)= load [<0-9 ]*[A-zx> 0-9%\.]*,")
regexFast = re.compile(r"(?P<prefix>.*)fast")
regexWriteOnly = re.compile(r"(?P<prefix>.*)writeonly")
regexArgmemonly = re.compile(r"(?P<prefix>.*)argmemonly")
regexNonnull = re.compile(r"(?P<prefix>.*)nonnull")

with open(sys.argv[1], 'r') as file_LLVM_40:
    with open(sys.argv[2], "w") as file_LLVM_34:
        for line in file_LLVM_40:
            newLine = line
            if (regexSourceFile.match(line)):
                newLine = regexSourceFile.sub("", line)
            elif (regexMetadataLine.match(line)):
                newLine = "".join((line[0], line[1:].replace(line[0], "metadata !")))
                newLine = newLine.replace("distinct", "")
            elif (regexGEPArr.match(line)):
                newLine = regexGEPArr.sub("\g<prefix>getelementptr\g<attr>", line)
            elif (regexGEP.match(line)):
                newLine = regexGEP.sub("\g<prefix>getelementptr\g<attr>", line)
            elif (regexLoad.match(line)):
                newLine = regexLoad.sub("\g<prefix>= load", line)
            elif (regexFast.match(line)):
                newLine = regexFast.sub("\g<prefix>", line)
            elif (regexWriteOnly.match(line)):
                newLine = regexWriteOnly.sub("\g<prefix>", line)
            elif (regexArgmemonly.match(line)):
                newLine = regexArgmemonly.sub("\g<prefix>", line)
            elif (regexNonnull.match(line)):
                newLine = regexNonnull.sub("\g<prefix>", line)
            file_LLVM_34.write(newLine)
