; ModuleID = 'vecadd.c'
target datalayout = "e-p:64:64:64-i1:8:8-i8:8:8-i16:16:16-i32:32:32-i64:64:64-f32:32:32-f64:64:64-v64:64:64-v128:128:128-a0:0:64-s0:64:64-f80:128:128-n8:16:32:64-S128"
target triple = "x86_64-unknown-linux-gnu"

%allocateResult_ty = struct { i32* }
define void @allocateResult(i32 %size, %allocateResult_ty* %out) {
  %sext = shl i64 %size, 32
  %0 = ashr exact i64 %sext, 30
  %1 = tail call noalias i8* @malloc(i64 %0) #3
  %2 = bitcast i8* %1 to i32*

  %ptr = getelementptr inbounds %allocateResult_ty* *%out, i64 0, i64 0
  store i32* %2, %ptr
  ret void
}

%vecadd_ty = struct { i32* }
define void @vecadd(i32* %adata, i32* %bdata, i32* %cdata, %vecadd_ty* %out) {
entry:
  %node = call i8* @llvm.visc.getNode()
  %idx = call i32 @llvm.VISC.getNodeInstanceID(%node)

  %idxprom = sext i32 %idx to i64
  %arrayidxa = getelementptr inbounds i32* %adata, i64 %idxprom
  %a = load i32* %arrayidxa
  %arrayidxb = getelementptr inbounds i32* %bdata, i64 %idxprom
  %b = load i32* %arrayidxb

  %add = add nsw i32 %a, %b
  %arrayidxc = getelementptr inbounds i32* %cdata, i64 %idxprom
  store i32 %add, i32* %arrayidxc, align 4

  %ptr = getelementptr inbounds %vecadd_ty* *%out, i64 0, i64 0
  store i32* %cdata, %ptr
  ret void
}

%wrapperKernelFunction_ty = struct { i32* }
define void @wrapperKernelFunction(i32 %n, i32* nocapture %A, i32* nocapture %B, %wrapperKernelFunction_ty* %out) {

  %node = call i8* @llvm.visc.getNode()

  %allocate_result_node = call i8* @llvm.visc.createNode(@allocateResult)
  %vecadd_node = call i8* @llvm.visc.createNode1D(@vecadd, %n)

  %edge0 = call i8* @llvm.visc.createEdge(%node, %allocate_result_node, @fmap4, @argmap4)
  %edge1 = call i8* @llvm.visc.createEdge(%node, %vecadd_node, @fmap5, @argmap5)
  %edge2 = call i8* @llvm.visc.createEdge(%allocate_result_node, %vecadd_node, @fmap6, @argmap6)
  %edge3 = call i8* @llvm.visc.createEdge(%vecadd_node, %node, @fmap7, @argmap7)

}

; This function does not return a result. Is type of %out void* ?
define i32 @cleanupFunction(i8* %A, i8* %B, i8* %C, void* %out) {
  tail call void @free(i8* %A) #3
  tail call void @free(i8* %B) #3
  tail call void @free(i8* %C) #3
  ret i32 0
}

%initializeFunction_ty = struct { i32, i32*, i32* }
define i32 @initializeFunction(i8** %arg, %initializeFunction_ty* %out) {
  %1 = getelementptr inbounds i8** %arg, i64 1
  %2 = load i8** %1, align 8, !tbaa !0
  %3 = tail call i64 @strtol(i8* nocapture %2, i8** null, i32 10) #3
  %4 = trunc i64 %3 to i32
  %sext = shl i64 %3, 32
  %5 = ashr exact i64 %sext, 30
  %6 = tail call noalias i8* @malloc(i64 %5) #3
  %7 = bitcast i8* %6 to i32*
  %8 = tail call noalias i8* @malloc(i64 %5) #3
  %9 = bitcast i8* %8 to i32*

  %12 = icmp sgt i32 %4, 0
  br i1 %12, label %.lr.ph, label %._crit_edge

.lr.ph:                                           ; preds = %0, %.lr.ph
  %indvars.iv = phi i64 [ %indvars.iv.next, %.lr.ph ], [ 0, %0 ]
  %13 = tail call i32 @rand() #3
  %14 = srem i32 %13, 1000
  %15 = getelementptr inbounds i32* %7, i64 %indvars.iv
  store i32 %14, i32* %15, align 4, !tbaa !3
  %16 = tail call i32 @rand() #3
  %17 = srem i32 %16, 1000
  %18 = getelementptr inbounds i32* %9, i64 %indvars.iv
  store i32 %17, i32* %18, align 4, !tbaa !3
  %indvars.iv.next = add i64 %indvars.iv, 1
  %lftr.wideiv = trunc i64 %indvars.iv.next to i32
  %exitcond = icmp eq i32 %lftr.wideiv, %4
  br i1 %exitcond, label %._crit_edge, label %.lr.ph

._crit_edge:                                      ; preds = %.lr.ph, %0
  %ptrN = getelementptr inbounds %initializeFunction_ty* *%out, i64 0, i64 0
  store i32* %4, %ptrN
  %ptrA = getelementptr inbounds %initializeFunction_ty* *%out, i64 0, i64 1
  store i32* %7, %ptrA
  %ptrB = getelementptr inbounds %initializeFunction_ty* *%out, i64 0, i64 2
  store i32* %9, %ptrB
  ret i32 0
} ;

; Function Attrs: nounwind uwtable
define i32 @main(i32 %argc, i8** nocapture %argv) #0 {

  %node = call i8* @llvm.visc.getNode()

  %init_node = call i8* @llvm.visc.createNode(@initializeFunction)
  %kernel_node = call i8* @llvm.visc.createNode(@wrapperKernelFunction)
  %cleanup_node = call i8* @llvm.visc.createNode(@cleanupFunction)

  %edge0 = call i8* @llvm.visc.createEdge(%node, %init_node, @fmap0, @argmap0)
  %edge1 = call i8* @llvm.visc.createEdge(%init_node, %kernel_node, @fmap1, @argmap1)
  %edge2 = call i8* @llvm.visc.createEdge(%init_node, %cleanup_node, @fmap2, @argmap2)
  %edge3 = call i8* @llvm.visc.createEdge(%kernel_node, %cleanup_node, @fmap3, @argmap3)

  ret i32 0
}


; FUNCTIONS FOR EDGES

; There is only one instance of both nodes, so this function is not needed
define i1 @fmap0(i32 %i, i32 %j) {
  ret true
}

define i1 @argmap0(i32 %i, i32 %j) {
  %0 = icmp eq i32 %i, 1
  %1 = icmp eq i32 %j, 0
  %res = and i1 %0, %1
  ret %res
}

; There is only one instance of both nodes, so this function is not needed
define i1 @fmap1(i32 %i, i32 %j) {
  ret true
}

define i1 @argmap1(i32 %i, i32 %j) {
  %res = icmp eq i32 %i, %j
  ret %res
}

; There is only one instance of both nodes, so this function is not needed
define i1 @fmap2(i32 %i, i32 %j) {
  ret true
}

define i1 @argmap2(i32 %i, i32 %j) {
  %0 = icmp eq i32 %i, 1
  %1 = icmp eq i32 %i, 2
  %out_arg = and i1 %0, %1

  %in_arg = add i32 %j, 1
  %eq = icmp eq i32 %i, %j

  %res = and i1 %out_arg, %eq
  ret %res
}

; There is only one instance of both nodes, so this function is not needed
define i1 @fmap3(i32 %i, i32 %j) {
  ret true
}

define i1 @argmap3(i32 %i, i32 %j) {
  %0 = icmp eq i32 %i, 0
  %1 = icmp eq i32 %j, 2
  %res = and i1 %0, %1
  ret %res
}

; There is only one instance of both nodes, so this function is not needed
define i1 @fmap4(i32 %i, i32 %j) {
  ret true
}

define i1 @argmap4(i32 %i, i32 %j) {
  %res = icmp eq i32 %i, %0
  ret %res
}

; There is an edge from the unique instance of the source node to all the
; instances of the destination node
define i1 @fmap5(i32 %i, i32 %j) {
  ret true
}

define i1 @argmap5(i32 %i, i32 %j) {
  %0 = icmp eq i32 %i, 1
  %1 = icmp eq i32 %i, 2
  %out_arg = and i1 %0, %1

  %in_arg = add i32 %j, 1
  %eq = icmp eq i32 %i, %out_arg

  %res = and i1 out_arg, %eq
  ret %res
}

; There is an edge from the unique instance of the source node to all the
; instances of the destination node
define i1 @fmap6(i32 %i, i32 %j) {
  ret true
}

define i1 @argmap6(i32 %i, i32 %j) {
  %0 = icmp eq i32 %i, 0
  %1 = icmp eq i32 %j, 2
  %res = and i1 %0, %1
  ret %res
}

; There are edges from all the instances of the source node to the unique
; instance of the destination node
define i1 @fmap7(i32 %i, i32 %j) {
  ret true
}

define i1 @argmap7(i32 %i, i32 %j) {
  ret true
}

declare i8* @llvm.visc.getNode() nounwind readnone

declare i32 @llvm.VISC.getNodeInstanceID(i8*) nounwind readnone

; Function Attrs: nounwind
declare noalias i8* @malloc(i64) #1

; Function Attrs: nounwind
declare i32 @rand() #1

declare void @vectorAdd(i32, i32*, i32*, i32*) #2

; Function Attrs: nounwind
declare void @free(i8* nocapture) #1

; Function Attrs: nounwind
declare i64 @strtol(i8*, i8** nocapture, i32) #1

attributes #0 = { nounwind uwtable "less-precise-fpmad"="false" "no-frame-pointer-elim"="false" "no-frame-pointer-elim-non-leaf"="false" "no-infs-fp-math"="false" "no-nans-fp-math"="false" "unsafe-fp-math"="false" "use-soft-float"="false" }
attributes #1 = { nounwind "less-precise-fpmad"="false" "no-frame-pointer-elim"="false" "no-frame-pointer-elim-non-leaf"="false" "no-infs-fp-math"="false" "no-nans-fp-math"="false" "unsafe-fp-math"="false" "use-soft-float"="false" }
attributes #2 = { "less-precise-fpmad"="false" "no-frame-pointer-elim"="false" "no-frame-pointer-elim-non-leaf"="false" "no-infs-fp-math"="false" "no-nans-fp-math"="false" "unsafe-fp-math"="false" "use-soft-float"="false" }
attributes #3 = { nounwind }

!0 = metadata !{metadata !"any pointer", metadata !1}
!1 = metadata !{metadata !"omnipotent char", metadata !2}
!2 = metadata !{metadata !"Simple C/C++ TBAA"}
!3 = metadata !{metadata !"int", metadata !1}
